apps/pro/ui/config/routes.rb
begin
  # Try Pro::Application first as it won't autoload, so if it doesn't raise a NameError, then this must be called
  # from pro/ui
  engine = Pro::Application
rescue NameError
  # Used in metasploit-pro-engine and metamodules specs
  engine = Metasploit::Pro::UI::Engine
end

#change
engine.routes.draw do
  get "/campaign_files/:id" => "social_engineering/files#download"

  # The RESTful API
  namespace :rest_api do
    namespace :v1 do
      get "/base/" => "base#index"

      namespace :social_engineering do
        resources :target_lists
        resources :human_targets

        resources :campaigns do
          resources :web_pages
          resources :emails
          resources :email_openings
          resources :phishing_results
          resources :visits
        end
      end
    end
    namespace :v2 do
      get "/base/" => "base#index"

      namespace :social_engineering do
        resources :target_lists
        resources :human_targets
      end

      resources :workspaces, only: [:index, :show] do
        resources :campaigns, only: [:index, :show], controller: 'social_engineering/campaigns' do
          resources :web_pages, only: [:index, :show], controller: 'social_engineering/web_pages'
          resources :emails, only: [:index, :show], controller: 'social_engineering/emails'
          resources :email_openings, only: [:index, :show], controller: 'social_engineering/email_openings'
          resources :phishing_results, only: [:index, :show], controller: 'social_engineering/phishing_results'
          resources :visits, only: [:index, :show], controller: 'social_engineering/campaigns/visits'
        end
        resources :hosts, only: [:index, :show] do
          resources :sessions, only: [:index, :show]
          resources :notes, only: [:index, :show]
          resources :services, only: [:index, :show] do
            resources :vulns, only: [:index, :show]
            resources :web_sites, only: [:index, :show] do
              resources :web_forms, only: [:index, :show]
              resources :web_pages, only: [:index, :show]
              resources :web_vulns, only: [:index, :show]
            end
          end
        end
      end
    end
  end

  # Wizards
  namespace :wizards do
    namespace :quick_pentest do
      resources :form
    end
    namespace :quick_web_app_scan do
      resources :form
    end
    namespace :vuln_validation do
      resources :form do
        collection do
          get  :nexpose_sites
          get  :import_run
          post :continue_exploitation
        end
      end
    end
    namespace :payload_generator do
      resources :form do
        collection do
          get :poll
          get :download
          get :upsell
        end
      end
    end
  end

  # Notifications
  namespace :notifications do
    resources :messages do
      collection do
        post 'mark_read' => 'messages#mark_read', :as => 'mark_read'
        get 'poll' => 'messages#poll', :as => 'poll'
      end
    end
  end

  # Setup & Licenses
  scope "/setup" do
    get ""           => "licenses#setup", :as => "setup"
    get "request"    => "licenses#request_key", :as => "request_key"
    get "activation" => "licenses#activation", :as => "activation"
  end

  scope "/licenses" do
    get ""        => "licenses#index",    :as => "licenses"
    post "register" => "licenses#register", :as => "register"
    post "activate" => "licenses#activate", :as => "activate"
    match "offline_activation" => "licenses#offline_activation", :as => "offline_activation", :via => [:get, :post]
  end

  # Updates
  scope "/updates" do
    get ""             => "updates#updates", :as => "updates"
    post "check"         => "updates#check"
    post "apply"         => "updates#apply"
    post "restart"       => "updates#restart"
    post "status"        => "updates#status"
    get  "offline_apply" => "updates#offline_apply"
    post "offline_apply_post" => "updates#offline_apply_post", :as => 'updates_offline_apply_post'
  end

  # NeXpose Consoles
  resources :nexpose_consoles do
    collection do
      delete "/destroy" => "nexpose_consoles#destroy", :as => "destroy"
    end
  end

  # API Keys
  resources :api_keys do
    collection do
      delete "/destroy" => "api_keys#destroy", :as => "destroy"
    end

    member do
      post "/reveal" => "api_keys#reveal"
    end
  end



  # Macros
  resources :macros
  scope "/macro" do
    delete ":id/delete_action/:action_id" => "macros#delete_action", :as => "macro_delete_action"
    delete ":id/delete_action" => "macros#delete_action", :as => "macro_delete_actions"
    post ":id/add_action" => "macros#add_action", :as => "macro_add_action"
    match "module_options" => "macros#module_options", :as => "module_options", via: [:get, :post]
  end
  delete "macros" => "macros#destroy", :as => "delete_macros"


  # Listeners
  resources :listeners
  scope "/listener" do
    post ":id/stop" => "listeners#stop", :as => "listener_stop"
    post ":id/start" => "listeners#start", :as => "listener_start"
    get "module_options" => "listeners#module_options", :as => "macro_module_options"
  end
  delete "listeners" => "listeners#destroy", :as => "delete_listeners"


  # Global Settings
  scope "/settings" do
    get "" => "settings#index", :as => "settings"
    patch "update_profile" => "settings#update_profile", :as => "update_profile"
    put "update_profile" => "settings#update_profile"
  end


  # Mdm::User settings
  resources :users

  get "login" => "user_sessions#new", :as => "login"
  get "logout" => "user_sessions#destroy", :as => "logout"

  resources :user_sessions

  # Workspaces
  get "/workspaces/search" => "workspaces#search"
  delete "/workspaces/destroy" => "workspaces#destroy"

  # Wizard related reporting routes
  get '/wizard_report_tab' => 'reports#form_for_tabbed_modal', :as => 'wizard_report_tab_form'

  resources :workspaces do
    get "sessions" => "sessions#index"
    get "events" => "events#index"
    get "web" => "web#index"

    resources :imports, only: [:new]


    # Reports and Exports
    # Standard reports
    resources :reports do
      collection do
        post  "validate_report" => "reports#validate_report", :as=> "validate_report"
        # Wrapper to allow all the other report partials
        # to be reloaded once type is selected:
        get :form_for_type
        delete :destroy_multiple
      end
      member do
        get :clone
        post :generate_format
        post :format_generation_status
      end

      # Generated report files
      resources :report_artifacts, only: [:destroy, :index] do
        member do
          get :download
          get :view
        end

        collection do
          post :email
        end
      end
    end

    # Outside of reports to avoid dealing with report IDs unnecessarily:
    get 'report_artifact_download/(:id)',       to: 'report_artifacts#download'
    get 'report_artifact_view/:id',             to: 'report_artifacts#view'

    # Custom reports
    resources :custom_reports, { :controller => :reports }

    # Resources for custom reports: logos, templates
    resources :report_custom_resources

    # Example simple template
    get 'report_template_simple_download',      to: 'reports#download_simple_sample'

    resources :exports do
      member do
        get 'download' => 'exports#download'
      end
      collection do
        delete :destroy_multiple
      end
    end

    resources :task_chains, except: [:show] do
      collection do
        post "validate_schedule" => 'task_chains#validate_schedule', :as => 'validate_schedule'
        post "validate" => 'task_chains#validate', :as=>'validate'
        delete :destroy_multiple
        post   :stop_multiple
        post   :suspend_multiple
        post   :resume_multiple
        post   :start_multiple
      end

      member do
        get :clone
      end
    end

    namespace :fuzzing do
      resources :fuzzing do
        resources :request_groups
      end
    end

    namespace :nexpose do
      namespace :result do
        # fixme: CHANGE TO POST TO PREVENT CSRF.
        get 'push_validations' => 'exceptions#push_validations'
        resources :exceptions, only: [:create, :show, :update]
        resources :validations, only: [:create, :show, :update]
      end
      namespace :data do
        resources :sites, only: [:index] do
          collection {
            get :search_operators
            get :filter_values
          }
        end
        resources :import_runs, only:[:create,:show]
      end
    end


    # NEW STYLE!
    # Social Engineering Campaigns
    namespace :social_engineering do
      resources :human_targets

      resources :web_templates, except: [:delete] do
        collection do
          post :clone_proxy
          delete "" => "web_templates#destroy", :as => "delete"
        end
      end

      resources :email_templates, except: [:delete]  do
        collection do
          delete "" => "email_templates#destroy", :as => "delete"
        end
      end

      resources :target_lists, except: [:delete]  do
        get "export" => "target_lists#export"
        post "remove_targets" => "target_lists#remove_targets"
        collection do
          delete "" => "target_lists#destroy", :as => "delete"
        end
      end

      resources :files, except: [:delete]  do
        collection do
          delete "" => "files#destroy", :as => "delete"
        end
      end

      # ------ Campaigns, components, and tracking data -----
      resources :campaigns do

        resource :web_server_config, {
            :only => [:edit, :update],
            :controller => :web_server_config
        }
        resource :email_server_config, {
            :only => [:edit, :update],
            :controller => :email_server_config
        } do
          collection do
            match :check_smtp, via: [:put, :patch]
          end
        end

        resources :visits

apps/pro/ui/app/models/social_engineering/campaign_file.rb
# Explicitly require carrierwave so mount_uploader is defined for prosvc
require 'carrierwave/orm/activerecord'

class SocialEngineering::CampaignFile < ActiveRecord::Base
  self.table_name = :se_campaign_files

  #
  # CONSTANTS
  #

  VALID_CONTENT_DISPOSITIONS = ["attachment", "inline"]

  #
  # Associations
  #

  belongs_to :attachable, :polymorphic => true

  #
  # Callbacks
  #

  before_validation(:on => :create) do
    if self.content_disposition.blank?
      self.content_disposition = "attachment"
      return true
    end
  end

  #
  # Uploaders
  #

  mount_uploader :attachment, SocialEngineering::CampaignFileUploader

  #
  # Validations
  #

  validates :content_disposition, :inclusion => VALID_CONTENT_DISPOSITIONS, :presence => true

  def attachment_url
    "/campaign_files/#{id}"
  end

  # For setting a MIME message part's Content-ID header
  def content_id
    @content_id ||= Rex::Text.to_hex(attachment.identifier + id.to_s, '')
  end

  attr_writer :content_id

  def to_s
    attachment.to_s
  end
end

apps/pro/ui/app/models/social_engineering/campaign_runner.rb
module SocialEngineering
  class CampaignRunner
    include ApplicationHelper

    def self.start(campaign, current_user)
      campaign.launch
      task = CampaignTask.new(campaign)
      task.start

      campaign.started_at = Time.now.utc
      campaign.started_by_user = current_user
      campaign.save!
    end

    def self.stop(campaign)
      campaign.finish
      tasks = Mdm::Task.find_running_campaign_tasks(campaign)
      tasks.each(&:rpc_stop)
    end
  end
end

apps/pro/ui/app/models/social_engineering/campaign_task.rb
class SocialEngineering::CampaignTask < TaskConfig
	attr_accessor :campaign

	def initialize(campaign)
		super({
      :campaign => campaign,
      :workspace => campaign.workspace
    })
    @campaign = campaign
	end

	def rpc_call
		client.start_se_campaign({
			'workspace' => @workspace.name,
			'DS_CAMPAIGN_ID' => @campaign.id
		})
	end
end

apps/pro/ui/app/models/social_engineering/configurable_campaign_checker.rb
module SocialEngineering
  class ConfigurableCampaignChecker
    def self.configured?(campaign)
      return false if empty?(campaign)
      only_usb?(campaign) || 
        ( 
          configured_web_campaign?(campaign) && 
          configured_email_campaign?(campaign) &&
          configured_phishing_campaign?(campaign)
        )
    end

    private

    def self.empty?(campaign)
      campaign.portable_files.blank?  &&
      campaign.web_pages.blank? &&
      campaign.emails.blank?
    end

    def self.only_usb?(campaign)
      campaign.usb_campaign?  && 
      !campaign.web_campaign? &&
      !campaign.email_campaign?
    end
 
    def self.configured_web_campaign?(campaign)
      if campaign.web_campaign?
        campaign.web_pages.all?(&:configured?) && campaign.web_host.present? &&
          campaign.web_port.present?
      else
        true
      end
    end

    def self.configured_email_campaign?(campaign)
      if campaign.email_campaign?
        campaign.smtp_configured?
      else
        true
      end
    end

    def self.configured_phishing_campaign?(campaign)
      if campaign.uses_wizard?
        !campaign.web_pages.empty? && !campaign.emails.empty?
      else
        true
      end
    end
  end
end

apps/pro/ui/app/models/social_engineering/configurable_campaign_observer.rb
module SocialEngineering
  class ConfigurableCampaignObserver < ActiveRecord::Observer
    observe SocialEngineering::Email,
            SocialEngineering::WebPage,
            SocialEngineering::PortableFile,
            SocialEngineering::Campaign

    def after_create(record)
      if component?(record)
        record.campaign.configure!
      end
    end

    def after_save(record)
      if component?(record)
        record.campaign.configure!
      else
        record.configure!
      end
    end

    def after_destroy(record)
      if component?(record)
        record.campaign.configure!
      end
    end
    
    private

    def component?(record)
      record.respond_to?(:campaign)  
    end
  end
end

apps/pro/ui/app/models/social_engineering/email_attack_config_interface.rb
#
#
# Implements basic interface for Email serialized attack configuration
#
#


module SocialEngineering::EmailAttackConfigInterface
  def self.included(base)
    raise "must be included by ActiveRecord::Base descendent" unless base.ancestors.include? ActiveRecord::Base

    base.class_eval do
      extend MetasploitDataModels::SerializedPrefs

      #
      # Serialized attributes - ordered by attribute name
      #
      #-------- Attack type: attached_file -> *
      serialized_prefs_attr_accessor :attachment_file_name
      serialized_prefs_attr_accessor :file_generation_type
      serialized_prefs_attr_accessor :user_supplied_file
      serialized_prefs_attr_accessor :zip_attachment
      #-------- Attack type: attached_file -> file_format
      serialized_prefs_attr_accessor :exploit_module_config
      serialized_prefs_attr_accessor :exploit_module_path

      #
      # Validations - ordered by attribute name
      #
      # need a desired attachment file name when attack_type=attached_file
      validates :attachment_file_name, :presence => { :message => "can't be blank", :if => :file_attack? }
      # make sure exploit config is present during file format attack
      validates :exploit_module_config, :presence => true, :if => :file_format_attack?
      validates :exploit_module_path, :presence => true, :if => :file_format_attack?
      # need an uploaded file when attack_type=exe_agent or user_supplied
      validates :user_supplied_file, :presence => { :message => "can't be blank", :if => :user_supplied_attack? }
      validate  :validate_attachment_filename

      # Make sure we know what KIND of attack file we are doing
      with_options :if => :file_attack? do |attack|
        attack.validates :file_generation_type,
                            :presence => true,
                            :inclusion => {:in => SocialEngineering::WebPage::VALID_FILE_GENERATION_TYPES}
      end

      def validate_attachment_filename
        if attachment_file_name.present?
          invalid_chars = attachment_file_name.scan(/[^\w\.\-]/)
          errors.add(:attachment_file_name, "contained invalid characters(#{invalid_chars.uniq.join(',')})") unless invalid_chars.empty?
        end
      end

      # returns the MsfModule
      def exploit_module
        return nil unless file_format_attack?
        MsfModule.find_by_fullname exploit_module_path
      end

      def file_attack?
        attack_type == "file"
      end

      def exe_agent_attack?
        file_attack? && file_generation_type == "exe_agent"
      end

      def file_format_attack?
        file_attack? && file_generation_type == "file_format"
      end
      
      def user_supplied_attack?
        file_attack? && file_generation_type == "user_supplied"
      end

      def zip_attachment?
        zip_attachment == "1"
      end

    end
  end
end

apps/pro/ui/app/models/social_engineering/email_send.rb
class SocialEngineering::EmailSend < ActiveRecord::Base
  self.table_name = :se_email_sends

  #
  # Associations
  #

  belongs_to :email, :class_name => "SocialEngineering::Email"
  belongs_to :human_target, :class_name => "SocialEngineering::HumanTarget"

  #
  # Scopes
  #

  scope :in_campaign, lambda { |campaign| where(email_id: campaign.emails) }

  #
  # Validations
  #

  validates :email, :presence => true
  validates :human_target, :presence => true

  def self.remove_for(campaign)
    results = in_campaign(campaign)
    destroy(results.collect(&:id))
  end
end

apps/pro/ui/app/views/social_engineering/campaigns/_campaign_configuration.html.erb
<div class='campaign-configuration'>
  <%= semantic_form_for [:workspace, @campaign], :html => {:onsubmit => 'return false'} do |f| %>
    <%= f.inputs do %>
      <%= f.input :name %>
      <%= f.input :config_type, :as => 'radio', 
                                :label => false,
                                :required => true,
                                :collection => SocialEngineering::Campaign::CAMPAIGN_CONFIG_TYPES_FORMATTED,
                                :selected => 'ok' %>
    <% end %>
  <% end %>
  <div class='row'></div>
</div>

apps/pro/ui/app/views/social_engineering/campaigns/_campaign_control_bar.html.erb
<div class="control-bar" style='margin-bottom: 0;'>
  <% campaign_status_for do |status| %>
    <% if status.executable? %>
      <span class="button">
        <%= link_to status.next_execute_action, 
                  execute_workspace_social_engineering_campaign_path(@workspace, @campaign), 
                  :confirm => status.confirmation, 
                  :method => :get,
                  :class  => status.css_class,
                  :remote => true %>
      </span>
    <% end %>
  <% end %>
  <span class="button">
    <%= link_to "Reset", reset_workspace_social_engineering_campaign_path, :class => "restart", :confirm => "Are you sure you want to reset this campaign? Any associated tracking information will be deleted." %>
  </span>
  <div class='rule'></div>
  <span class="button">
    <a href="#" class='report'>
      Report
    </a>
  </span>
  <div class='rule'></div>
  <span class="button">
    <a href="#" class='schedule'>
      Schedule
    </a>
  </span>
  <div class='control-right'>
    <span class="button">
      <%= link_to_if(!@campaign.running?, "Edit Campaign", edit_workspace_social_engineering_campaign_path, :class => "edit") do %>
        <a id="edit_denied" href="#" class="edit">Edit Campaign</a>
      <% end %>
    </span>
    <span class="button">
      <a href="#" class='delete'>
        Delete
      </a>
    </span>
  </div>
</div>

apps/pro/ui/app/views/social_engineering/campaigns/_campaign_facts.html.erb
<div class='campaign-findings'>
  <div class='campaign-facts-header header rollup-header'>
    <div class='max-width'>
      <h3 style='display:inline-block'>{{ campaignDetails.name }}: Findings</h3>
      <span class="btn report-btn primary">
        <a href="<%= new_workspace_report_path(@workspace, @campaign) %>" target="_blank" class="primary">Generate Report</a>
      </span>
    </div>
   </div>
  <div class='max-width tab-container' style='padding-top: 52px'>
    <ul class='tabs'>
      <li class='tab'>
        <a class='active' href='javascript:void'>Campaign Facts</a>
      </li>
      <li class='tab'>
        <a href='javascript:void'>Task Log</a>
      </li>
    </ul>
    <div class='tabs'>
      <div class='tab'>
        <div class='campaign-findings-inner-gray'>
          <div class='campaign-circles-wrapper'>
          </div>
          <div class='campaign-facts-wrapper'>
            <div class='border-box campaign-facts'>
              <div class='circles'>
              </div> <!-- end .circles -->
              {% if (this['showTray']) { %}
                <div class='row'>
                  <div class='cell first'>
                    <!-- invisibly clear this much text. BLAAAARRRRF -->
                  </div>
                </div>
                <div class='shadow-arrow-row'>
                  <div class='shadow-arrow'></div>
                </div>
                <div class='tray'></div>
              {% } %}
            </div>
          </div>
        </div>
      </div>

      <div class='tab' style='display:none'>
        <div class='tab-loading task-console' style='min-height:250px'>
          <table class='list header'></table>
          <pre class='console logs'></pre>
        </div>
      </div>
    </div>
  </div>
</div>

apps/pro/ui/app/views/social_engineering/campaigns/_campaign_list.html.erb
<div class='campaign-list'>
  {% if (this.collection.models.length) { %}
    {% _.each(this.collection.models, function(campaign) { %}
      {% campaignDetails = campaign.get('campaign_details') %}
      <div class='row' campaign-id='{{ campaign.id }}'>
        <div class='cell title'>
          <label class='title'>
            <span>Campaign: {{ Helpers.truncate(campaignDetails.name, 65) }}</span>
          </label>
          <label class='date'>Started: {{ campaignDetails.started_at }}</label>
        </div>
        <div class='cell components'>
          <ul>
            {% if (campaignDetails.email_count + 
                   campaignDetails.web_page_count + 
                   campaignDetails.portable_files_count == 0) { %}
                <li class='empty'>No components</li>
            {% } else { %}
              {% if (campaignDetails.email_count > 0) { %}
                <li class='emails'>{{ campaignDetails.email_count }}</li>
              {% } %}
              {% if (campaignDetails.web_page_count > 0) { %}
                <li class='web-pages'>{{ campaignDetails.web_page_count }}</li>
              {% } %}
              {% if (campaignDetails.portable_files_count > 0) { %}
                <li class='portable-files'>{{ campaignDetails.portable_files_count }}</li>
              {% } %}
            {% } %}

          </ul>
          <div class='updated-at'>
            Updated: {{ campaignDetails.updated_at }}
          </div>
        </div>
        <div class='cell launch' style='padding-top:27px'>
            {% if (campaign.launchable()) { %}
              <a href='campaigns/{{ campaign.id }}/to_task' target='_blank' class='link3 big start'>Start</a>
            {% } %}
            {% if (campaign.running() || campaign.preparing()) { %}
              <a href='#' class='link3 big stop-campaign'>Stop</a>
            {% } %}
        </div>
        <div class='cell status'>
          <div>
            <label class='status {{ campaignDetails.current_status.toLowerCase() }}'>
              {{ campaignDetails.current_status }}
            </label>
          </div>
          <div class='actions'>            
            <!-- <a class='test first' href='#'>Test</a>
            | -->
            {% if (campaign.hasWebPagesOrEmails()) { %}
              <a class='preview' href='#'>Preview</a> |
            {% } %}

            {% if (campaign.hasBeenLaunched()) { %}
              <a class='findings' href='#'>Findings</a>
            | 
              {% if (campaign.running() || campaign.preparing()) { %}
                <a class='reset ui-disabled' href='#'>Reset</a>
              {% } else { %}
                <a class='reset' href='#'>Reset</a>
              {% } %}
            |
            {% } %}
            {% if (campaign.running() || campaign.preparing()) { %}
              <a class='edit ui-disabled' href='#'>Edit</a>
            {% } else { %}
              <a class='edit' href='#'>Edit</a>
            {% } %}
            |
            <a class='delete last {{ (campaign.running() || campaign.preparing()) ? "ui-disabled" : "" }}' href='#'>Delete</a>
          </div>
        </div>
      </div>
    {% }); %}
  {% } else { %}
    <div class='empty-row'>
      No campaigns have been created. Click the "Configure a Campaign" tab to start setting one up.
    </div>
  {% } %}
</div>

apps/pro/ui/app/views/social_engineering/campaigns/_campaign_notification.html.erb
<div class='notifications-wrapper' style="margin-bottom: 23px">
  
  {% if(campaignSummary.id) { %}
  <h3 class="max-width">Notifications</h3>
  <div class="list section campaign-notification">
    <p>
      <label style='color:#444;'>
        <input type="checkbox" style="vertical-align:baseline;" name="social_engineering_campaign[prefs][notifications_enabled]">
        Notify others before launching the campaign
      </label>
      <a class="notification-settings" href="#" style="display:none">
        Settings
      </a>
    </p>
  </div>
  {% } %}

  <div id="notification-dialog" style="display:none;padding: .4em 1em;">
    <form class='formtastic notification-dialog'>
      <li>
        <p>Notify the following users before launching the campaign:</p>
      </li>
      <div class='errors' style='display:none;margin:0 0 10px;font-size:12px'>

      </div>
      <li class="email input optional stringish" id="social_engineering_campaign_notification_email_address_input">
        <label class=" label" for="social_engineering_campaign_notification_email_address">To</label>
        <input id="social_engineering_campaign_notification_email_address" maxlength="255" name="social_engineering_campaign[notification_email_address]" type="email">
        <br />
        <p style="font-size: .9em;color:#999;">Separate multiple email addresses with commas</p>

      </li>
      <li class="email input optional stringish" id="social_engineering_campaign_notification_email_subject_input">
        <label class=" label" for="social_engineering_campaign_notification_email_subject">Subject</label>
        <input id="social_engineering_campaign_notification_email_subject" maxlength="255" name="social_engineering_campaign[notification_email_subject]" type="email">
      </li>
      
      <li class="text input optional" id="social_engineering_campaign_notification_email_message_input">
        <label class=" label" for="social_engineering_campaign_notification_email_message">Message</label>
        <textarea id="social_engineering_campaign_notification_email_message" name="social_engineering_campaign[notification_email_message]" rows="20"></textarea>
      </li>
    </form>
    <p style='font-size:11px'><strong>Note:</strong> Notification Email will be sent through the SMTP server specified in your <%= link_to "Global Settings", settings_path, :style => 'text-decoration:underline;color:#069 !important;', :target => '_blank' %></p>
  </div>
</div>

apps/pro/ui/app/views/social_engineering/campaigns/_campaigns.erb
<table id="campaigns-table" class="sortable list">
  <thead>
    <tr>
      <th class="checkbox"><%= check_box_tag "all_hosts", false %></th>
      <th>Name</th>
      <th>Emails</th>
      <th>Web Pages</th>
      <th>Status</th>
      <th>Creation Date</th>
    </tr>
  </thead>
  <tbody>
    <% campaigns.each do |camp| %>
      <tr class="<%=h row_cycle %>">
        <td width="1">
          <%= check_box_tag("campaign_ids[]", camp.id, false, :id => nil) %>
        </td>
        <td><%= link_to camp.name, workspace_social_engineering_campaign_path(@workspace.id, camp.id) %></td>
        <td width="50px"><%= camp.emails.count %></td>
        <td width="80px"><%= camp.web_pages.count %></td>
        <td><%= campaign_status_for(camp).current_state %></td>
        <td>
          <span title="<%= camp.created_at.to_i %>"></span>
          <%= camp.created_at ? "#{time_ago_in_words(camp.created_at)} ago" : "never" %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

apps/pro/ui/app/views/social_engineering/campaigns/_reusable_elements.html.erb
<div class='reusable-elements'>
  <div class='max-width' style='padding:0 20px'>
    <div style='position: absolute; top: 22px; right: 15px'>
      <span class='link3 delete-span ui-disabled'>
        <a class='delete-btn' href='#'>Delete</a>
      </span>
      <span class='btn primary'>
        <a href='<%= workspace_social_engineering_email_templates_path(@workspace) %>/new' class='new'>New</a>
      </span>
    </div>
    <label>Resource: <%= select_tag :element_type, options_for_select([
      ['Target Lists', workspace_social_engineering_target_lists_path(@workspace)],
      ['Email Templates', workspace_social_engineering_email_templates_path(@workspace)],
      ['Web Templates', workspace_social_engineering_web_templates_path(@workspace)],
      ['Malicious Files', workspace_social_engineering_files_path(@workspace)]
    ]), :style => 'width: 250px' %></label>
    <div class='status'>
    </div>
    <%= form_tag :method => :post do %>
      <input type='hidden' name='_method' value='DELETE' />
      <div class='table loading'>
        <!-- datatable goes here. -->
        <table class='list sortable'>
          <thead></thead>
          <tbody></tbody>
        </table>
      </div>
    <% end %>
  </div>
</div>